# coding: utf-8

"""
    Maneuver Planning API

    Maneuver Planning API

    The version of the OpenAPI document: 1.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from spacetower_maneuver_planning_python_client.models.reflection_absorption_coefficients import ReflectionAbsorptionCoefficients
from spacetower_maneuver_planning_python_client.models.solar_array_geometry import SolarArrayGeometry
from spacetower_maneuver_planning_python_client.models.thruster import Thruster
from typing import Optional, Set
from typing_extensions import Self

class BoxObjectWithoutPowerSystem(BaseModel):
    """
    Common fields for box objects having or not a power system defined 
    """ # noqa: E501
    mass: Union[StrictFloat, StrictInt] = Field(description="Units [kg]")
    drag_coefficient: Optional[Union[StrictFloat, StrictInt]] = Field(default=2.2, description="Dimensionless drag coefficient. Units [-]", alias="dragCoefficient")
    x_dimension: Optional[Union[StrictFloat, StrictInt]] = Field(default=1, description="Box dimension along X axis. Units [m]", alias="xDimension")
    y_dimension: Optional[Union[StrictFloat, StrictInt]] = Field(default=1, description="Box dimension along Y axis. Units [m]", alias="yDimension")
    z_dimension: Optional[Union[StrictFloat, StrictInt]] = Field(default=1, description="Box dimension along Z axis. Units [m]", alias="zDimension")
    solar_array_geometry: Optional[SolarArrayGeometry] = Field(default=None, alias="solarArrayGeometry")
    radiation_coefficients: Optional[ReflectionAbsorptionCoefficients] = Field(default=None, alias="radiationCoefficients")
    thruster: Optional[Thruster] = None
    __properties: ClassVar[List[str]] = ["mass", "dragCoefficient", "xDimension", "yDimension", "zDimension", "solarArrayGeometry", "radiationCoefficients", "thruster"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BoxObjectWithoutPowerSystem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of solar_array_geometry
        if self.solar_array_geometry:
            _dict['solarArrayGeometry'] = self.solar_array_geometry.to_dict()
        # override the default output from pydantic by calling `to_dict()` of radiation_coefficients
        if self.radiation_coefficients:
            _dict['radiationCoefficients'] = self.radiation_coefficients.to_dict()
        # override the default output from pydantic by calling `to_dict()` of thruster
        if self.thruster:
            _dict['thruster'] = self.thruster.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BoxObjectWithoutPowerSystem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "mass": obj.get("mass"),
            "dragCoefficient": obj.get("dragCoefficient") if obj.get("dragCoefficient") is not None else 2.2,
            "xDimension": obj.get("xDimension") if obj.get("xDimension") is not None else 1,
            "yDimension": obj.get("yDimension") if obj.get("yDimension") is not None else 1,
            "zDimension": obj.get("zDimension") if obj.get("zDimension") is not None else 1,
            "solarArrayGeometry": SolarArrayGeometry.from_dict(obj["solarArrayGeometry"]) if obj.get("solarArrayGeometry") is not None else None,
            "radiationCoefficients": ReflectionAbsorptionCoefficients.from_dict(obj["radiationCoefficients"]) if obj.get("radiationCoefficients") is not None else None,
            "thruster": Thruster.from_dict(obj["thruster"]) if obj.get("thruster") is not None else None
        })
        return _obj


