# coding: utf-8

"""
    Maneuver Planning API

    Maneuver Planning API

    The version of the OpenAPI document: 1.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class PropulsionPowerModel(BaseModel):
    """
    The propulsion system
    """ # noqa: E501
    active_propulsion_power_consumption: Union[StrictFloat, StrictInt] = Field(description="The power consumed by the thruster during the burn phase. Units [W] ", alias="activePropulsionPowerConsumption")
    warmup_propulsion_power_consumption: Optional[Union[StrictFloat, StrictInt]] = Field(default=0, description="The power consumed by the thruster during the warm-up phase. Units [W] ", alias="warmupPropulsionPowerConsumption")
    warmup_duration: Optional[Union[StrictFloat, StrictInt]] = Field(default=0, description="The duration of the the thruster warm-up phase taking place before each firing. Units [s] ", alias="warmupDuration")
    __properties: ClassVar[List[str]] = ["activePropulsionPowerConsumption", "warmupPropulsionPowerConsumption", "warmupDuration"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PropulsionPowerModel from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PropulsionPowerModel from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "activePropulsionPowerConsumption": obj.get("activePropulsionPowerConsumption"),
            "warmupPropulsionPowerConsumption": obj.get("warmupPropulsionPowerConsumption") if obj.get("warmupPropulsionPowerConsumption") is not None else 0,
            "warmupDuration": obj.get("warmupDuration") if obj.get("warmupDuration") is not None else 0
        })
        return _obj


