# coding: utf-8

"""
    Maneuver Planning API

    Maneuver Planning API

    The version of the OpenAPI document: 1.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from importlib import import_module
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from spacetower_maneuver_planning_python_client.models.single_arc_thrust_pattern_configuration import SingleArcThrustPatternConfiguration
    from spacetower_maneuver_planning_python_client.models.two_arcs_thrust_pattern_configuration import TwoArcsThrustPatternConfiguration

class ThrustPatternConfiguration(BaseModel):
    """
    ThrustPatternConfiguration
    """ # noqa: E501
    thrust_arcs_number: StrictStr = Field(alias="thrustArcsNumber")
    mean_longitude_shift_from_thrust_arc_center: Optional[Union[StrictFloat, StrictInt]] = Field(default=0, description="This parameter is used to define the mean equinoctial longitude shift from the thrust  arc center defined by the thrustArcsCenter parameter. If this is different from 0,  the center of each thrust arc will be shifted by this value. This is true for both single and two-arc configurations. Units [rad] ", alias="meanLongitudeShiftFromThrustArcCenter")
    number_of_thrust_orbits: Optional[StrictInt] = Field(default=1, description="The number of consecutive orbits on which burns will be performed ", alias="numberOfThrustOrbits")
    number_of_rest_orbits: Optional[StrictInt] = Field(default=0, description="The number of consecutive orbits on which no burn will be performed ", alias="numberOfRestOrbits")
    __properties: ClassVar[List[str]] = ["thrustArcsNumber", "meanLongitudeShiftFromThrustArcCenter", "numberOfThrustOrbits", "numberOfRestOrbits"]

    @field_validator('thrust_arcs_number')
    def thrust_arcs_number_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['ONE', 'TWO']):
            raise ValueError("must be one of enum values ('ONE', 'TWO')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = 'thrustArcsNumber'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'ONE': 'SingleArcThrustPatternConfiguration','TWO': 'TwoArcsThrustPatternConfiguration'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Union[SingleArcThrustPatternConfiguration, TwoArcsThrustPatternConfiguration]]:
        """Create an instance of ThrustPatternConfiguration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[Union[SingleArcThrustPatternConfiguration, TwoArcsThrustPatternConfiguration]]:
        """Create an instance of ThrustPatternConfiguration from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type ==  'SingleArcThrustPatternConfiguration':
            return import_module("spacetower_maneuver_planning_python_client.models.single_arc_thrust_pattern_configuration").SingleArcThrustPatternConfiguration.from_dict(obj)
        if object_type ==  'TwoArcsThrustPatternConfiguration':
            return import_module("spacetower_maneuver_planning_python_client.models.two_arcs_thrust_pattern_configuration").TwoArcsThrustPatternConfiguration.from_dict(obj)

        raise ValueError("ThrustPatternConfiguration failed to lookup discriminator value from " +
                            json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                            ", mapping: " + json.dumps(cls.__discriminator_value_class_map))


